// THEFISH.INC  gjpateman

#declare Amb = 0 // .1

#declare ManPig = pigment {
  mandel 25 //150
  color_map {
    [ 0.0  color Gold    ]
    [ 0.2  color Brown   ]
    [ 0.4  color Orange  ]
    [ 0.6  color Yellow  ]
    [ 0.8  color Red     ]
    [ 1.0  color Gold    ]
  }
  frequency 0.592156862745098
  phase 0
  translate < 1.512412575, -1.97439999999934e-07, 0 >
  scale < 181.934454474087, 181.92822259212, 1 >
  scale .3
  rotate x * 90
}

#declare T = texture {
  pigment { ManPig }
  finish { Shiny  ambient Amb  diffuse 1 }
}

#declare EyeFin = finish { phong 1  ambient .5  diffuse 1  reflection .2 }

#declare EyeTex =   texture { pigment { White }       finish { EyeFin }  }
#declare PupilTex = texture { pigment { MediumBlue }  finish { EyeFin }  }
#declare FinTex = texture { T }

#declare Dorsals = object{
  intersection {
    sphere { <0,0,0>,1 scale <5,3,.2> }
    sphere { <0,0,0>,1 scale <5,3,.3>  inverse  translate <-2.3,0,0>  }
  }
  scale<1, .75, 1>
  translate <-3,0,0>
  texture { FinTex  rotate z * 45  }
}

#declare mainbody = union{
  object { sphere { <0,0,0>,1 scale <3.90, 1.20, .4> } }
  object { sphere { <0,0,0>,1 scale <4.25,  .90, .3> } }
  texture{ T }
}

#declare TailFin = intersection {      // crescent from two spheres
  sphere { <0,0,0>,1 scale <4,2,.2> }
  sphere { <0,0,0>,1 scale <4,2,.3> inverse translate <-1.3,0,0> }
  texture { FinTex }
}

#declare FishBody =
union {

  intersection{ // both halves of the main body with a mouth cut out
    object{ mainbody }
    cylinder{<0,0,0>,<6,-.5,0>, 0.2  inverse
      pigment{ color Black }
      scale <1, .2, 1> // .1
    }
  }

  /*
      No sense tracing the eyes at this distance

  object { sphere { <3.00, .4,  .4>, .3  texture{T} } } // left socket
  object { sphere { <3.00, .4, -.4>, .3  texture{T} } } // right socket

  object { sphere { <3.15, .4,  .4>, .2  texture{EyeTex} } } // left eyeball
  object { sphere { <3.15, .4, -.4>, .2  texture{EyeTex} } } // right eyeball

  object { sphere { <3.30, .4,  .4>, .1  texture{PupilTex} } } // left pupil
  object { sphere { <3.30, .4, -.4>, .1  texture{PupilTex} } } // right pupil
  */

  object { Dorsals }                            // vertical
  object { Dorsals  rotate x * 90  scale .75 }  // horizontal

  object { TailFin  scale<  1, .5, 1  >  translate < -6.5, 0, 0 > }

}
